namespace X3DTK {
namespace MESH {

template<class MData, class VData, class EData, class FData, bool readOnly>
ConnComView<MData, VData, EData, FData, readOnly>::ConnComView(QMainWindow *parent) 
: View("connected components"), dock(new MeshConnComDock(parent))
{
  _connComComputer = X3DProcessor::getInstanceOf<ConnectedComComputer<MData, VData, EData, FData, readOnly> >();
  
  RC::Route::connect(dock, &MeshConnComDock::compute, this, &ConnComView<MData, VData, EData, FData, readOnly>::compute);
}

template<class MData, class VData, class EData, class FData, bool readOnly>
ConnComView<MData, VData, EData, FData, readOnly>::~ConnComView()
{
  RC::Route::disconnect(dock, &MeshConnComDock::compute, this, &ConnComView<MData, VData, EData, FData, readOnly>::compute);
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void ConnComView<MData, VData, EData, FData, readOnly>::hide()
{
  View::hide();
  dock->hide();
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void ConnComView<MData, VData, EData, FData, readOnly>::show()
{
  View::show();
  dock->show();
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void ConnComView<MData, VData, EData, FData, readOnly>::compute()
{
  _connComComputer->compute(getScene());
  notify();
}

template<class MData, class VData, class EData, class FData, bool readOnly>
void ConnComView<MData, VData, EData, FData, readOnly>::setSelectedNodes(const MFNode &selectedNodes)
{
  _connComComputer->setSelectedNodes(selectedNodes);
}

}
}
